"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Grant = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The ``mysql.Grant`` resource creates and manages privileges given to
 * a user on a MySQL server.
 *
 * ## Examples
 *
 * ### Granting Privileges to a User
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as mysql from "@pulumi/mysql";
 *
 * const jdoe = new mysql.User("jdoe", {
 *     user: "jdoe",
 *     host: "example.com",
 *     plaintextPassword: "password",
 * });
 * const jdoeGrant = new mysql.Grant("jdoe", {
 *     user: jdoe.user,
 *     host: jdoe.host,
 *     database: "app",
 *     privileges: [
 *         "SELECT",
 *         "UPDATE",
 *     ],
 * });
 * ```
 *
 * ### Granting Privileges to a Role
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as mysql from "@pulumi/mysql";
 *
 * const developer = new mysql.Role("developer", {name: "developer"});
 * const developerGrant = new mysql.Grant("developer", {
 *     role: developer.name,
 *     database: "app",
 *     privileges: [
 *         "SELECT",
 *         "UPDATE",
 *     ],
 * });
 * ```
 *
 * ### Adding a Role to a User
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as mysql from "@pulumi/mysql";
 *
 * const jdoe = new mysql.User("jdoe", {
 *     user: "jdoe",
 *     host: "example.com",
 *     plaintextPassword: "password",
 * });
 * const developer = new mysql.Role("developer", {name: "developer"});
 * const developerGrant = new mysql.Grant("developer", {
 *     user: jdoe.user,
 *     host: jdoe.host,
 *     database: "app",
 *     roles: [developer.name],
 * });
 * ```
 */
class Grant extends pulumi.CustomResource {
    /**
     * Get an existing Grant resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Grant(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Grant.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Grant.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["database"] = state ? state.database : undefined;
            resourceInputs["grant"] = state ? state.grant : undefined;
            resourceInputs["host"] = state ? state.host : undefined;
            resourceInputs["privileges"] = state ? state.privileges : undefined;
            resourceInputs["role"] = state ? state.role : undefined;
            resourceInputs["roles"] = state ? state.roles : undefined;
            resourceInputs["table"] = state ? state.table : undefined;
            resourceInputs["tlsOption"] = state ? state.tlsOption : undefined;
            resourceInputs["user"] = state ? state.user : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.database === undefined) && !opts.urn) {
                throw new Error("Missing required property 'database'");
            }
            resourceInputs["database"] = args ? args.database : undefined;
            resourceInputs["grant"] = args ? args.grant : undefined;
            resourceInputs["host"] = args ? args.host : undefined;
            resourceInputs["privileges"] = args ? args.privileges : undefined;
            resourceInputs["role"] = args ? args.role : undefined;
            resourceInputs["roles"] = args ? args.roles : undefined;
            resourceInputs["table"] = args ? args.table : undefined;
            resourceInputs["tlsOption"] = args ? args.tlsOption : undefined;
            resourceInputs["user"] = args ? args.user : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Grant.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Grant = Grant;
/** @internal */
Grant.__pulumiType = 'mysql:index/grant:Grant';
//# sourceMappingURL=grant.js.map